
local entity = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity)
local parent = EntityGetWithTag("player_unit")[1]
local effect = nil
local matcomp = EntityGetFirstComponentIncludingDisabled(entity, "MaterialInventoryComponent")
local drank = ComponentGetValue2(matcomp, "last_frame_drank")

if drank > 0 then
    local name = (EntityGetFilename(entity):gsub("data/entities/items/pickup/", "")):gsub(".xml", "")
    if name == "sun/sunseed" then name = "sunseed" end
    if name == "brimstone" then
        effect = LoadGameEffectEntityTo(parent, "data/entities/misc/effect_eat_brimstone.xml")
        GamePrint("Swallowed Kivaskivi")
    elseif name == "thunderstone" then
        effect = LoadGameEffectEntityTo(parent, "data/entities/misc/effect_eat_thunderstone.xml")
        EntityAddComponent(effect, "ElectricitySourceComponent", {_tags="thunderstone", radius="24", emission_interval_frames="32",})
        GamePrint("Swallowed Ukkoskivi")
    elseif name == "stonestone" then
        effect = EntityCreateNew()
        EntityAddComponent(effect, "InheritTransformComponent", {})
        EntityAddComponent(effect, "LuaComponent", {_tags="stonestone", script_kick="data/scripts/items/stonestone.lua", execute_every_n_frame="-1",})
        GamePrint("Swallowed Tannerkivi")
    elseif name == "waterstone" then
        effect = LoadGameEffectEntityTo(parent, "data/entities/misc/effect_breath_underwater.xml")
        GamePrint("Swallowed Vuoksikivi")
    elseif name == "poopstone" then
        GamePrint("Swallowed Kakkakikkare")
    elseif name == "sunseed" then
        effect = LoadGameEffectEntityTo(parent, "data/entities/misc/effect_remove_fog_of_war.xml")
        GamePrint("Swallowed AuringonSiemen")
    elseif name == "wandstone" then
        effect = LoadGameEffectEntityTo(parent, "data/entities/misc/effect_edit_wands_everywhere.xml")
        GamePrint("Swallowed Sauvan Ydin")
    end

    if not EntityGetParent(effect) == parent then EntityAddChild(parent, effect) end
    EntitySetName(effect, name)
    EntityAddTag(effect, "swallowed")
    local comp = EntityGetFirstComponentIncludingDisabled(effect, "GameEffectComponent")
    ComponentSetValue2(comp, "frames", -1)
    EntityInflictDamage(parent, 0.4, "DAMAGE_DROWNING", "Choking", "NORMAL", 0, 0)
    EntityKill(entity)
end
