for iter, perk in pairs(perk_list) do
	if perk["id"] == "FOOD_CLOCK" then
		perk_list[iter] = {
			id = "FOOD_CLOCK",
			ui_name = "$perk_food_clock",
			ui_description = "You inflict more damage the more healthy food you're full of, but start to lose health when you're not digesting any.",
			ui_icon = "data/ui_gfx/perk_icons/mystery_eggplant.png",
			perk_icon = "data/items_gfx/perks/mystery_eggplant.png",
			stackable = STACKABLE_NO,
			func = function( entity_perk_item, entity_who_picked, item_name )
				EntityAddComponent( entity_who_picked, "LuaComponent", { 
					_tags = "FOOD_CLOCK",
					script_shot = "data/scripts/perks/food_clock_damage.lua",
					execute_every_n_frame = "1",
					} )
				EntityAddTag( entity_who_picked, "FOOD_CLOCK" )
			end,
			func_remove = function( entity_who_picked )
				EntityRemoveComponent(entity_who_picked, EntityGetFirstComponent(entity_who_picked, "LuaComponent", "FOOD_CLOCK"))
				EntityRemoveTag(entity_who_picked, "FOOD_CLOCK")
			end,
			}
	elseif perk["id"] == "IRON_STOMACH" then
		perk_list[iter] = {
			id = "IRON_STOMACH",
			ui_name = "$perk_iron_stomach",
			ui_description = "$perkdesc_iron_stomach",
			ui_icon = "data/ui_gfx/perk_icons/iron_stomach.png",
			perk_icon = "data/items_gfx/perks/iron_stomach.png",
			game_effect = "IRON_STOMACH",
			stackable = STACKABLE_NO,
			func = function( entity_perk_item, entity_who_picked, item_name )
				EntityAddTag( entity_who_picked, "iron_stomach" )
			end,
			func_remove = function( entity_who_picked )
				EntityRemoveTag(entity_who_picked, "iron_stomach")
			end,
			}
	end
end
table.insert(perk_list,
  {
    id = "SYMBIOTE",
    ui_name = "Symbiote",
    ui_description = "Parasites are naturally inclined to do your bidding",
    ui_icon = "mods/ir/files/symbiote_ui.png",
    perk_icon = "mods/ir/files/symbiote_perk.png",
	stackable = STACKABLE_NO,
    usable_by_enemies = true,
    not_in_default_perk_pool = false, 
    func = function( entity_perk_item, entity_who_picked, item_name )
    	EntityAddTag(entity_who_picked, "worm_charmer")
    end,
	func_remove = function( entity_who_picked )
		EntityRemoveTag(entity_who_picked, "worm_charmer")
	end,
  }
)