-----------------------------------------------------------------------------------------
--SETUP
-----------------------------------------------------------------------------------------
dofile_once("mods/ir/files/functions.lua")

local entity = GetUpdatedEntityID()
x,y = EntityGetTransform(entity)
local expelletory_status = EntityGetFirstComponentIncludingDisabled(entity, "VariableStorageComponent", "expelletory_status")
local flowy_gas = ModSettingGet("ir.flowy_gas") == "yes"
local hard_mode = ModSettingGet("ir.difficulty") == "hard"
local food_clock = EntityHasTag(entity, "FOOD_CLOCK") == true
local iron_stomach = EntityHasTag(entity, "iron_stomach") == true

local all_worms = {}
local stomach = entity
local bladder = nil
local colon = nil
local vomit_entity = nil
local vomitcomp = nil
local toxic_immune = false
local fire_immune = false
local brimstone = false
local waterstone = false
local sunseed = false
local wandstone = false
local swallowed_entities = {}
local swallowed_entities_display = {}
local swallowed_entity_space = 0
for i, child in pairs(EntityGetAllChildren( entity )) do
	local child_name = EntityGetName(child)
	if EntityHasTag(child, "vomit") then
		vomit_entity = child
		vomitcomp = EntityGetFirstComponentIncludingDisabled( vomit_entity, "ParticleEmitterComponent", "VOMIT" )
	elseif EntityHasTag(child, "bladder") then
		bladder = child
	elseif EntityHasTag(child, "colon") then
		colon = child
	elseif child_name == "effect_protection" then
		local gec = EntityGetFirstComponent( child, "GameEffectComponent", "effect_protection" )
		local effect = ComponentGetValue2(gec, "effect")
		if effect == "PROTECTION_RADIOACTIVITY" then toxic_immune = true end
		if effect == "PROTECTION_FIRE" then fire_immune = true end
	elseif child_name == "worm" then
		table.insert(all_worms, child)
	elseif EntityHasTag(child, "swallowed") then
		local stone_count = swallowed_entities_display[child_name]
		if stone_count then
			swallowed_entities_display[child_name][2]  = stone_count[2] + 1
		else
			swallowed_entities_display[child_name]  = {child_name, 1}
		end
		swallowed_entity_space = swallowed_entity_space + 200
		table.insert(swallowed_entities, child_name)
		if child_name == "brimstone" then
			local fire_count = getMaterialCount("fire")
			AddMaterialInventoryMaterial(entity, "fire", fire_count + 2)
			brimstone = true
		elseif child_name == "poopstone" then
			local diarrhea_count = getMaterialCount("diarrhea")
			AddMaterialInventoryMaterial(entity, "diarrhea", diarrhea_count + 1)
		elseif child_name == "waterstone" then
			waterstone = true
		elseif child_name == "sunseed" then
			sunseed = true
		elseif child_name == "wandstone" then
			wandstone = true
		end
	end
end
local worm_count = #all_worms


if bladder == nil then
	EntityRemoveComponent( entity, EntityGetFirstComponentIncludingDisabled( entity, "MaterialInventoryComponent"))
	EntityAddComponent( entity, "MaterialInventoryComponent", {_tags="ingestion",})
	local bladder = EntityCreateNew()
	local colon = EntityCreateNew()
	EntityAddTag( bladder, "bladder" )
	EntityAddTag( colon, "colon" )
	EntityAddComponent( bladder, "MaterialInventoryComponent", {})
	EntityAddComponent( colon, "MaterialInventoryComponent", {})
	EntityAddChild( entity, bladder )
	EntityAddChild( entity, colon )
end
if vomit_entity == nil then 
	vomit_entity = EntityLoad( "data/entities/particles/vomit.xml", x, y )
	EntityAddTag( vomit_entity, "vomit" )
	EntityAddChild( entity, vomit_entity )
	vomitcomp = EntityGetFirstComponentIncludingDisabled( vomit_entity, "ParticleEmitterComponent", "VOMIT" )
end


local peecomp = EntityGetFirstComponentIncludingDisabled( entity, "ParticleEmitterComponent", "URINE" )
local poocomp = EntityGetFirstComponentIncludingDisabled( entity, "ParticleEmitterComponent", "FECES" )
local fartcomp = EntityGetFirstComponentIncludingDisabled( entity, "ParticleEmitterComponent", "FARTICLES" )

local controls = EntityGetFirstComponentIncludingDisabled( entity, "ControlsComponent" )
local dmc = EntityGetFirstComponentIncludingDisabled(entity, "DamageModelComponent")
local stats = EntityGetFirstComponentIncludingDisabled(entity, "StatusEffectDataComponent")
local effects = ComponentGetValue2(stats, "stain_effects")
local hp = ComponentGetValue2(dmc, "hp")
local max_hp = ComponentGetValue2(dmc, "max_hp")
local max_hp_cap = tonumber( ComponentGetValue2(dmc, "max_hp_cap") )
local blood = ComponentGetValue2(dmc, "blood_spray_material")
if blood == "oil" then fire_immune = true end
local entity_vel_x, entity_vel_y = GameGetVelocityCompVelocity(entity)
local fpc = EntityGetFirstComponentIncludingDisabled( entity, "VariableStorageComponent", "fpc" )
local crouching = EntityGetFirstComponentIncludingDisabled( entity, "VariableStorageComponent", "crouching" )
crouch = false

-----------------------------------------------------------------------------------------
--FUNCTIONS
-----------------------------------------------------------------------------------------
function upchuck_stone(stone_name, x, y, vel_x, vel_y)
	local entity = GetUpdatedEntityID()
	local display_name = StoneDisplayName(stone_name)
	local path = "data/entities/items/pickup/" .. stone_name .. ".xml"
	local stone = EntityLoad(path, x, y-8)
	PhysicsApplyForce(stone, vel_x, vel_y)
	for i, child in ipairs(EntityGetAllChildren(entity)) do
		if EntityGetName(child) == stone_name then
			EntityKill(child) 
			break
		end
	end
	GamePrint("Upheaved " .. display_name)
end
function StoneDisplayName(stone)
	local displaynames = {
		brimstone="Kivaskivi", 
		thunderstone="Ukkoskivi", 
		stonestone="Tannerkivi", 
		waterstone="Vuoksikivi",
		poopstone="Kakkakikkare",
		sunseed="AuringonSiemen",
		wandstone="Sauvan Ydin"
	}
	return displaynames[stone]
end
function SkipFrames(number)
	if GameGetFrameNum() % number == 0 then return true end
	return false
end

-----------------------------------------------------------------------------------------
--MAKE TABLE OF ALL MATERIAL REACTIONS
-----------------------------------------------------------------------------------------
dofile("mods/ir/files/stringstore/stringstore.lua")
dofile("mods/ir/files/stringstore/noitaglobalstore.lua")
MY_EXTERN_GLOBAL = stringstore.open_store(stringstore.noita.global("MY_EXTERN_GLOBAL"))
if MY_EXTERN_GLOBAL.mat_data == nil then
	existing_reactions = {}
	--Material={Healthiness, Product, Destination(nil=stomach, 1=bladder, 2=colon), Effect}
	existing_processes = {
		magic_liquid_protection_all={0,			"urine",		1, 			"IRON_STOMACH"},
		vomit=						{0,		 	nil,			nil,		"FOOD_POISONING"},
		water_salt=					{0, 		"vomit",		0,			"FOOD_POISONING"},
		oil=						{0, 		"oil",			1,			"FOOD_POISONING"},
		radioactive_liquid=			{-0.01, 	"blood",		1,			"POISONED"},
		poo=						{-0.001, 	nil,			nil,		"FOOD_POISONING"},
		diarrhea=					{-0.01, 	nil,			nil,		"FOOD_POISONING"},
		slime=						{-0.004, 	nil,			nil,		"FOOD_POISONING"},
		meat_slime_sand=			{-0.003, 	nil,			nil,		"FOOD_POISONING"},
		rotten_meat=				{-0.003, 	nil,			nil,		"FOOD_POISONING"},
		meat_infested=				{-0.003, 	"poo",			2,			"WORM"},
		worm_egg=					{0,		 	"air",			2,			"WORM"},
		blood=						{0.002,		"urine",		1, 			nil},
		poison=						{-0.0001, 	nil,			nil,		"POISONED"},
		soil=						{0, 		"poo",			2,			nil},
		mud=						{0, 		"diarrhea",		2,			nil},
		meat=						{0.003, 	"poo",			2,			nil},
		meat_done=					{0.004, 	"poo",			2,			nil},
		meat_deep_fried=			{0.1, 		"poo",			2,			nil},
		meat_slime=					{0.003,		"diarrhea",		2,			"FOOD_POISONING"},
		meat_slime_green=			{-0.001, 	"blood",		nil,		"FOOD_POISONING"},
		rotten_meat_radioactive=	{-0.01, 	"blood",		2,			"POISONED"},
		meat_helpless=				{0.04494382,"poo",			2,			nil},
		meat_helpless_done=			{0.05, 		"poo",			2,			nil},
		honey=						{0.02, 		"diarrhea",		2,			nil},
		alcohol=					{0.01, 		"urine",		1,			"INGESTION_DRUNK"},
		sima=						{0.02, 		"urine",		1,			"INGESTION_DRUNK"},
		juhannussima=				{0.04, 		"urine",		1,			"INGESTION_DRUNK"},
		grass=						{0.001, 	"poo",			2,			nil},
		grass_ice=					{0.001, 	"poo",			2,			nil},
		grass_dry=					{0.001, 	"poo",			2,			nil},
		moss=						{0.001, 	"diarrhea",		2,			nil},
		beans=						{0.1, 		"poo",			2,			nil},
		cheese_static=				{0.004, 	"poo",			2,			nil}
	}

	local xml2lua = dofile("mods/ir/lib/xml2lua/xml2lua.lua")
	local handler = dofile("mods/ir/lib/xml2lua/xmlhandler/tree.lua")
	local parser = xml2lua.parser(handler)
	local materials = ModTextFileGetContent("data/materials.xml")
	parser:parse(materials)
	for i, p in pairs(handler.root.Materials) do
		if i == "CellDataChild" or i == "CellData" then
			for i2, p2 in pairs(handler.root.Materials[i]) do
				if p2.StatusEffects ~= nil then
					if p2.StatusEffects.Ingestion ~= nil then
						if p2.StatusEffects.Ingestion.StatusEffect ~= nil then
							if p2.StatusEffects.Ingestion.StatusEffect._attr ~= nil then
								if p2.StatusEffects.Ingestion.StatusEffect._attr.type ~= nil then --This is so stupid, why does Lua have zero try-except functionality for indexing a possibly-nil value? What a horrendous jumble of "if" statements I've been forced to make, just to find out if a table value exists. Lua sucks
									local ingestion_effect = p2.StatusEffects.Ingestion.StatusEffect._attr.type
									local material_name = p2._attr.name
									if existing_processes[material_name] == nil then
										local tags = CellFactory_GetTags(CellFactory_GetType(material_name))
										local healthiness = 0
										local product = material_name
										local destination = 2
										for i3, tag in pairs(tags) do
											if tag == "[fire]" then
												healthiness = healthiness - 0.01
												destination = nil
											elseif tag == "[gas]" then
												destination = nil
											elseif tag == "[molten]" then
												healthiness = healthiness - 0.01
												product = string.gsub(material_name, "_molten", "")
											elseif tag == "[lava]" then
												healthiness = healthiness - 0.01
												product = "rock_static"
											elseif tag == "[liquid]" then
												destination = 1
											end
											if tag == "[meat]" then
												healthiness = healthiness + 0.003
												product = "poo"
											end
											if tag == "[water]" or tag == "[meltable_to_water]" then
												product = "urine"
												destination = 1
											end
										end
										if ingestion_effect == "POISONED" then healthiness = -0.001 end
										existing_processes[material_name] = {healthiness,	product,	destination,	ingestion_effect}
									end
								end
							end
						end
					end
				end
			end
		end
		if i == "Reaction" then
			for i2, p2 in pairs(handler.root.Materials[i]) do
				if(p2._attr ~= nil)then
					local inputcount = 2
					new_reaction = {inputs={},outputs={}}
					if(p2._attr.input_cell1 ~= nil)then
						table.insert(new_reaction.inputs, p2._attr.input_cell1)
					end
					if(p2._attr.input_cell2 ~= nil)then
						table.insert(new_reaction.inputs, p2._attr.input_cell2)
					end
					if(p2._attr.input_cell3 ~= nil)then
						table.insert(new_reaction.inputs, p2._attr.input_cell3)
						inputcount = 3
					end
					if(p2._attr.output_cell1 ~= nil)then
						table.insert(new_reaction.outputs, p2._attr.output_cell1)
					end
					if(p2._attr.output_cell2 ~= nil)then
						table.insert(new_reaction.outputs, p2._attr.output_cell2)
					end
					if(p2._attr.output_cell3 ~= nil)then
						table.insert(new_reaction.outputs, p2._attr.output_cell3)
					end
					if(p2._attr.probability ~= nil)then
						new_reaction.probability = tonumber(p2._attr.probability)
					else
						new_reaction.probability = 100
					end

					if inputcount == 2 and p2._attr.input_cell1 ~= "air" and p2._attr.input_cell2 ~= "air" then
						existing_reactions[p2._attr.input_cell1 .. p2._attr.input_cell2] = new_reaction
					else
						--existing_reactions[p2._attr.input_cell1 .. p2._attr.input_cell2 .. p2._attr.input_cell3] = new_reaction --unused, couldn't figure out an efficient way of reacting more than 2 materials at a time
					end
				end
			end
		end
	end
	MY_EXTERN_GLOBAL.mat_data = {existing_reactions, existing_processes}
end

--if a material has an effect in materials.xml that's NOT listed existing_processes, cancel out the effect here:
EntityRemoveIngestionStatusEffect(entity, "POISONED")
EntityRemoveIngestionStatusEffect(entity, "FOOD_POISONING")
EntityRemoveIngestionStatusEffect(entity, "FARTS")

-----------------------------------------------------------------------------------------
--DIGESTION
-----------------------------------------------------------------------------------------
local hp_for_worms = 0
local processes = MY_EXTERN_GLOBAL.mat_data[2]
effects = {}
for i, material in pairs(IngestedMaterialsList()) do
	local material_count = getMaterialCount(material)
	local tags = CellFactory_GetTags(CellFactory_GetType(material))
	if material:find("gunpowder") and material ~= "gunpowder" then
		AddMaterialInventoryMaterial(entity, "gunpowder", material_count) 
		AddMaterialInventoryMaterial(entity, material, 0) 
		goto fin2
	end
	if waterstone then 
		if get_index(tags, "[hot]") or material == "smoke" then 
			AddMaterialInventoryMaterial(entity, material, 0)
			goto fin2
		end
	end
	if wandstone then 
		if get_index(tags, "[liquid]") and material ~= "magic_liquid_mana_regeneration" then 
			local manacount = getMaterialCount("magic_liquid_mana_regeneration")
			AddMaterialInventoryMaterial(entity, "magic_liquid_mana_regeneration", manacount + material_count) 
			AddMaterialInventoryMaterial(entity, material, 0)
		end
	end
	local material_properties = processes[material]
	if blood == "slime" and material == "meat_slime" then material_properties = nil end

	if material_properties ~= nil then 
		local healthiness = material_properties[1]
		local product = material_properties[2]
		local destination = material_properties[3] or stomach
		local destinations = {bladder, colon}
		if destination ~= stomach then destination = destinations[destination] end
		effect = material_properties[4] 
		local effect_exists_already = effects[effect] ~= nil
		if blood == material then
			if effect == "FOOD_POISONING" or effect == "POISONED" or healthiness < 0 then 
				effect = nil 
				healthiness = 0.002
				product = "urine"
				destination = bladder
			end
		end
		if toxic_immune then 
			if material:find("radioactive") then
				effect = nil
				healthiness = 0
				product = material
				destination = bladder
			elseif material == "meat_slime_green" then
				effect = nil
				healthiness = 0.003
				product = "poo"
				destination = bladder
			end
		end
		if effect == "INGESTION_ON_FIRE" then
			if fire_immune or waterstone or brimstone or blood == "oil" then
				EntityRemoveIngestionStatusEffect(entity, "INGESTION_ON_FIRE")
				effect = nil
				if waterstone then 
					AddMaterialInventoryMaterial(entity, material, 0) 
					goto fin2
				end
			end
		end

		if ComponentGetValue2(fpc, "value_int") == 1 then --if sick
			if effect ~= "FOOD_POISONING" then 
				effect = nil
				healthiness = 0
				destination = stomach
				if product == "poo" or product == "urine" or product == "diarrhea" then 
					product = "vomit" 
				else 
					product = nil
				end
			end
		elseif ComponentGetValue2(fpc, "value_int") == 2 then --if immune
			if healthiness < 0 then healthiness = 0 end
			if destination == stomach or effect == "FOOD_POISONING" or material == "worm_egg" or material == "meat_infested" then
				if SkipFrames(10) then
					product = material
					destination = colon
					for i, tag in pairs(tags) do
						if tag == "[liquid]" then 
							destination = bladder 
						end
						if tag == "[water]" or tag == "[meltable_to_water]" then 
							destination = bladder 
							product = "urine" 
						end
						if tag == "[meat]" or tag == "[food]" or tag == "[plant]" then 
							product = "poo" 
						end
					end
					if sunseed then product = "gunpowder_unstable" end
					AddMaterialInventoryMaterial(entity, material, material_count - 1)
					AddMaterialInventoryMaterial(destination, product, getMaterialCount(product, destination) + 1)
				end
				goto fin
			end
		end
		if material == "worm_egg" then 
			add_worms(entity, 1) 
			AddMaterialInventoryMaterial(entity, material, material_count - 1)
			goto fin2
		elseif material == "meat_infested" and math.random(100) == 1 then 
			add_worms(entity, 1) 
			AddMaterialInventoryMaterial(entity, material, material_count - 1)
			goto fin2
		end
		--WERM EAT YOUR FOOD:
		if worm_count > 0 then
			hp_for_worms = hp_for_worms + ((healthiness*100) / worm_count)
			healthiness = healthiness / (worm_count+1)
			if math.random(worm_count+1) ~= 1 then product = "air" end
		end

		--GamePrint(material .. " turns into " .. (product or material) .. " inside the " .. ({"stomach", "bladder", "colon"})[(material_properties[3] or 0)+1] .. ", contains " .. healthiness .. " calories, and causes " .. (effect or "no side effects"))
		if material == "meat_helpless" and not (hard_mode and hp < max_hp) then
			ComponentSetValue2(dmc, "max_hp", max_hp + (healthiness/100)) 
			if max_hp_cap > 0 and max_hp > max_hp_cap then
				ComponentSetValue2(dmc, "max_hp", max_hp_cap) 
			end
		end
		if material == "meat_deep_fried" then
			if max_hp - (healthiness/10) <= 0 then 
				EntityInflictDamage(entity, -(healthiness/10), "DAMAGE_MATERIAL", "heart attack", "NONE", 0, 0)
			else
				ComponentSetValue2(dmc, "max_hp", max_hp - (healthiness/100)) 
			end
		end
		if healthiness > -0.01 and healthiness ~= 0 then 
			hp = hp + (healthiness/10)
		elseif healthiness <= -0.01 and effects["IRON_STOMACH"] == nil then
			EntityInflictDamage(entity, -(healthiness/10), "DAMAGE_MATERIAL", "ingesting " .. material, "NONE", 0, 0) 
			crouch = true
		end
		if product ~= nil and SkipFrames(10) then
			if (product == "poo" or product == "diarrhea") and destination == colon then
				local gas_chance = math.floor(healthiness * 1000) + 1
				if healthiness < 0 then gas_chance = 0 end
				AddMaterialInventoryMaterial(destination, "acid_gas_static", getMaterialCount("acid_gas_static", destination) + math.random(0,gas_chance))
			end
			if material == "alcohol" or material == "sima" or material == "juhannussima" then
				local gas_chance = math.floor(healthiness * 1000) + 1
				AddMaterialInventoryMaterial(stomach, "alcohol_gas", getMaterialCount("alcohol_gas", stomach) + math.random(0,gas_chance))
			end
			if sunseed then product = "gunpowder_unstable" end
			AddMaterialInventoryMaterial(entity, material, material_count - 1)
			AddMaterialInventoryMaterial(destination, product, getMaterialCount(product, destination) + 1)
			
		end
		if effect ~= nil then
			if effect_exists_already then
				effects[effect][3] = effects[effect][3] + material_count
			else
				effects[effect] = {effect, material, material_count}
			end
		end
		::fin::
	elseif material_properties == nil then 
		if SkipFrames(10) then
			local tags = CellFactory_GetTags(CellFactory_GetType(material))
			local material_count = getMaterialCount(material)
			local product = material
			local destination = colon
			for i, tag in pairs(tags) do
				if tag == "[gas]" then
					destination = stomach
				end
				if tag == "[fire]" then
					destination = stomach
					if not brimstone and not fire_immune and blood ~= oil then
						EntityInflictDamage(entity, -0.1, "DAMAGE_MATERIAL", "ingesting " .. material, "NONE", 0, 0)  
					end
					product = "smoke"
				end
				if tag == "[liquid]" then
					destination = bladder 
				end
				if tag == "[water]" or tag == "[meltable_to_water]" then 
					destination = bladder 
					product = "urine" 
				end
				if tag == "[meat]" or tag == "[food]" or tag == "[plant]" then 
					product = "poo" 
				end
			end
			if ComponentGetValue2(fpc, "value_int") == 1 and ComponentGetValue2(fpc, "value_int") ~= 2 then 
				destination = stomach 
				if product == "poo" or product == "urine" or product == "diarrhea" then product = "vomit" end
			end
			if sunseed then product = "gunpowder_unstable" end
			AddMaterialInventoryMaterial(entity, material, material_count - 1)
			AddMaterialInventoryMaterial(destination, product, getMaterialCount(product, destination) + 1)
			--GamePrint(material .. " turns into " .. product .. "upon digestion")
		end
	end
	::fin2::
end

if food_clock or hard_mode then
	if hp >= 1 or hard_mode then
		hp = hp - 0.00007
		if hp < 0 then
			EntityInflictDamage( entity, 1, "MATERIAL", "exhaustion", "NORMAL", 0, 0)
		end
	end
end
ComponentSetValue2(dmc, "hp", math.max(0,hp))

for i, effect in pairs(effects) do
	local effect_name = effect[1]
	local material_that_caused = effect[2]
	local amount = effect[3] or 0
	local count_initial = getMaterialCount(material_that_caused)
	EntityRemoveIngestionStatusEffect(entity, effect_name)

	--GamePrint("ingesting " .. amount .. " cells of " .. material_that_caused .. " caused " .. effect_name)
	if not (effect_name:find("POLYMORPH") and effect_name ~= "PROTECTION_POLYMORPH") then
		EntityIngestMaterial( entity, CellFactory_GetType(material_that_caused), amount)
		AddMaterialInventoryMaterial(entity, material_that_caused, count_initial)
	elseif effects["IRON_STOMACH"] == nil then
		AddMaterialInventoryMaterial(entity, material_that_caused, 0)
	elseif getMaterialCount(effects["IRON_STOMACH"][2]) == 1 then
		EntityRemoveIngestionStatusEffect(entity, "IRON_STOMACH")
		EntityIngestMaterial( entity, CellFactory_GetType(material_that_caused), amount)
		AddMaterialInventoryMaterial(entity, material_that_caused, 0)
	end
end

sick_status = ComponentGetValue2(fpc, "value_int") --0=normal, 1=sick, 2=protected
vomitable_count = 0
if (effects["IRON_STOMACH"] ~= nil or iron_stomach) and sick_status ~= 1 then
	ComponentSetValue2(fpc, "value_int", 2)
elseif effects["FOOD_POISONING"] ~= nil and sick_status ~= 2 then 
	vomitable_count = effects["FOOD_POISONING"][3]
	ComponentSetValue2(fpc, "value_int", 1)
else
	ComponentSetValue2(fpc, "value_int", 0)
end



-----------------------------------------------------------------------------------------
--INTERMATERIAL REACTIONS
-----------------------------------------------------------------------------------------
local reactions = MY_EXTERN_GLOBAL.mat_data[1]
reactions["gunpowder[fire]"] = {inputs={"gunpowder", "[fire]"}, outputs={"fire", "fire"}}
reactions["[meat][fire]"] = {inputs={"[meat]", "[fire]"}, outputs={"meat_done", "smoke"}}
reactions["meat_helpless[fire]"] = {inputs={"meat_helpless", "[fire]"}, outputs={"meat_helpless_done", "smoke"}}
reactions["[burnable][fire]"] = {inputs={"[burnable]", "[fire]"}, outputs={"fire", "[fire]"}}
reactions["diarrheapoo"] = {inputs={"diarrhea", "poo"}, outputs={"diarrhea", "diarrhea"}}
for i, organ in pairs({stomach, bladder, colon}) do
	local iml = shuffle(IngestedMaterialsList(organ))
	if #iml < 2 then goto done end

	material_to_react = iml[1]
	other_material = iml[2]
	local materialTags1 = CellFactory_GetTags(CellFactory_GetType(material_to_react))
	local materialTags2 = CellFactory_GetTags(CellFactory_GetType(other_material))
	local reaction = nil
	local tag1 = "[]"
	local tag2 = "[]"
	if reactions[material_to_react .. other_material] ~= nil then					--Check if reaction exists for the material names
		reaction = reactions[material_to_react .. other_material]
		goto fin3
	elseif reactions[other_material .. material_to_react] ~= nil then					--flip names try again
		reaction = reactions[other_material .. material_to_react]
		goto fin3
	end
	if materialTags2 ~= nil and reaction == nil then					--If input material 2 has tags, check if any of the tags react with input material 1
		for j, othertag in pairs(materialTags2) do
			if othertag == nil then break end
			if reactions[material_to_react .. othertag] ~= nil then
				reaction = reactions[material_to_react .. othertag]
				tag2 = othertag
				goto fin3
			elseif reactions[othertag .. material_to_react] ~= nil then
				reaction = reactions[othertag .. material_to_react]
				tag2 = othertag
				goto fin3
			end
		end
	end
	if materialTags1 ~= nil and reaction == nil then				--If input material 1 has tags, check if any of the tags react with input material 2
		for j, tag in pairs(materialTags1) do
			if reactions[tag .. other_material] ~= nil then
				reaction = reactions[tag .. other_material]
				tag1 = tag
				goto fin3
			elseif reactions[other_material .. tag] ~= nil then
				reaction = reactions[tag .. material_to_react]
				tag1 = tag
				goto fin3
			end
		end
	end
	if materialTags1 ~= nil and materialTags2 ~= nil and reaction == nil then	--if both input materials have tags, check if any of the tags react with each other
		for j, tag in pairs(materialTags1) do
			for j, othertag in pairs(materialTags2) do
				if reactions[tag .. othertag] ~= nil then
					reaction = reactions[tag .. othertag]
					tag1 = tag
					tag2 = othertag
					goto fin3
				elseif reactions[othertag .. tag] ~= nil then
					reaction = reactions[othertag .. tag]
					tag1 = tag
					tag2 = othertag
					goto fin3
				end
			end
		end
	end
	::fin3::
	if reaction ~= nil then
		local amount_to_react = math.random(math.min(getMaterialCount(material_to_react, organ), getMaterialCount(other_material, organ)))
		if reaction["outputs"] ~= nil then
			for l=1,3 do
				local output = reaction["outputs"][l] 
				if output ~= nil then
					if output ~= "air" then
						if output == tag1 then output = material_to_react elseif output == tag2 then output = other_material end
						AddMaterialInventoryMaterial(organ, output, getMaterialCount(output, organ) + amount_to_react)
					end
				end
			end
		end
		if material_to_react:find("gunpowder") or other_material:find("gunpowder") then
			AddMaterialInventoryMaterial(organ, "fire", getMaterialCount("fire") + 100*amount_to_react)
		end
		--GamePrint(material_to_react ..  " + " .. other_material)
		AddMaterialInventoryMaterial(organ, material_to_react, getMaterialCount(material_to_react, organ) - amount_to_react)
		AddMaterialInventoryMaterial(organ, other_material, getMaterialCount(other_material, organ) - amount_to_react)
	end
	::done::
end


-----------------------------------------------------------------------------------------
--DEFECATION
-----------------------------------------------------------------------------------------
fert = false
if (getMaterialCount("all", colon) > 100 and ComponentGetValue2( controls, "mButtonDownInteract")) or (ComponentGetValue2(expelletory_status, "value_int") == 2) or getMaterialCount("diarrhea", colon) > 100 then

	--poo = EntityLoad("mods/ir/files/turd.xml", x, y) --A dynamic turd, couldn't get it to look right though

	local material_inventory = EntityGetFirstComponentIncludingDisabled(colon, "MaterialInventoryComponent")
	if material_inventory == nil then return end
	local count_per_material_type = ComponentGetValue2( material_inventory, "count_per_material_type")
	local empty = 1
	crouch = true

	for k,material_amount in pairs(count_per_material_type) do
		if material_amount ~= 0 then --material exists in the inventory
            local material_name = CellFactory_GetName(k-1)
			local count = math.random(0, material_amount)
			if get_index(CellFactory_GetAllGases(true, false), material_name) == nil and get_index(CellFactory_GetAllFires(true, false), material_name) == nil then
				ComponentSetValue2(poocomp, "x_vel_max", 0)
				ComponentSetValue2(poocomp, "x_vel_min", -20 - (count*0.1))
				ComponentSetValue2(poocomp, "y_vel_max", count*0.1)
				ComponentSetValue2(poocomp, "y_vel_min", 0)
				ComponentSetValue2(poocomp, "x_pos_offset_min", 0)
				ComponentSetValue2(poocomp, "x_pos_offset_max", 0)
				ComponentSetValue2(poocomp, "y_pos_offset_min", 0)
				ComponentSetValue2(poocomp, "y_pos_offset_max", 0)
				ComponentSetValue2(poocomp, "emitted_material_name", material_name)
				ComponentSetValue2(poocomp, "create_real_particles", false)
				ComponentSetValue2(poocomp, "count_min", math.floor(count*0.5))
				ComponentSetValue2(poocomp, "count_max", math.floor(count*0.5))
			else
				if flowy_gas then
					ComponentSetValue2(poocomp, "emitted_material_name", material_name)
					ComponentSetValue2(poocomp, "create_real_particles", true)
					ComponentSetValue2(poocomp, "x_pos_offset_min", -1)
					ComponentSetValue2(poocomp, "x_pos_offset_max", 1)
					ComponentSetValue2(poocomp, "y_pos_offset_min", -1)
					ComponentSetValue2(poocomp, "y_pos_offset_max", 1)
					ComponentSetValue2(poocomp, "count_min", count)
					ComponentSetValue2(poocomp, "count_max", count)
				else
					local x2,y2 = ComponentGetValue2( controls, "mAimingVector")
					local factor = 1
					if (x2 > 0 and entity_vel_x < 0) or (x2 < 0 and entity_vel_x > 0) then factor = -1 end
					ComponentSetValue2(fartcomp, "emitted_material_name", material_name)
					ComponentSetValue2(fartcomp, "x_vel_min", -40+(math.abs(entity_vel_x)*50*factor))
					ComponentSetValue2(fartcomp, "x_vel_max", -30+(math.abs(entity_vel_x)*50*factor))
					ComponentSetValue2(fartcomp, "y_vel_max", 10+(entity_vel_y*10))
					ComponentSetValue2(fartcomp, "y_vel_min", 0+(entity_vel_y*10))
					ComponentSetValue2(fartcomp, "count_min", count)
					ComponentSetValue2(fartcomp, "count_max", count)
					fert = true
				end
			end
			AddMaterialInventoryMaterial(colon, material_name, material_amount - count)
			if ComponentGetValue2(expelletory_status, "value_int") ~= 2 then
				ComponentSetValue2(expelletory_status, "value_int", 2)
				GamePlaySound( "data/audio/Desktop/projectiles.bank", "player_projectiles/bullet_slime/create", x, y )
			end
			empty = 0
			break
		end   
	end
	if empty == 1 then
		ComponentSetValue2(expelletory_status, "value_int", 0)
	end
else
	ComponentSetValue2(poocomp, "count_min", 0)
	ComponentSetValue2(poocomp, "count_max", 0)
end
-----------------------------------------------------------------------------------------
--FARTS
-----------------------------------------------------------------------------------------
local fartable = getMaterialCount("gases", colon) + getMaterialCount("fires", colon)
if (fartable > 100 and math.random(1+math.floor(100000/fartable)) == 1) or (ComponentGetValue2(expelletory_status, "value_int") == 4) then
	local material_inventory = EntityGetFirstComponentIncludingDisabled(colon, "MaterialInventoryComponent")
	if material_inventory == nil then return end
	local count_per_material_type = ComponentGetValue2( material_inventory, "count_per_material_type")
	local x2,y2 = ComponentGetValue2( controls, "mAimingVector")
	local factor = 1
	if (x2 > 0 and entity_vel_x < 0) or (x2 < 0 and entity_vel_x > 0) then factor = -1 end
	local count = math.random(0, 100)

	for k,v in pairs(count_per_material_type) do
		if v ~= 0 then --material exists in the inventory
            material_name = CellFactory_GetName(k-1)
            material_amount = v
			if get_index(CellFactory_GetAllGases(true, false), material_name) ~= nil or get_index(CellFactory_GetAllFires(true, false), material_name) ~= nil then
				if flowy_gas then
					ComponentSetValue2(poocomp, "emitted_material_name", material_name)
					ComponentSetValue2(poocomp, "create_real_particles", true)
					ComponentSetValue2(poocomp, "x_pos_offset_min", -1)
					ComponentSetValue2(poocomp, "x_pos_offset_max", 1)
					ComponentSetValue2(poocomp, "y_pos_offset_min", -1)
					ComponentSetValue2(poocomp, "y_pos_offset_max", 1)
					ComponentSetValue2(poocomp, "count_min", count)
					ComponentSetValue2(poocomp, "count_max", count)
				else
					ComponentSetValue2(fartcomp, "emitted_material_name", material_name)
					ComponentSetValue2(fartcomp, "x_vel_min", -40+(math.abs(entity_vel_x)*50*factor))
					ComponentSetValue2(fartcomp, "x_vel_max", -30+(math.abs(entity_vel_x)*50*factor))
					ComponentSetValue2(fartcomp, "y_vel_max", 10+(entity_vel_y*10))
					ComponentSetValue2(fartcomp, "y_vel_min", 0+(entity_vel_y*10))
					ComponentSetValue2(fartcomp, "count_min", count)
					ComponentSetValue2(fartcomp, "count_max", count)
				end
				AddMaterialInventoryMaterial(colon, material_name, getMaterialCount(material_name, colon) - count)
				if ComponentGetValue2(expelletory_status, "value_int") ~= 4 then
					ComponentSetValue2(expelletory_status, "value_int", 4)
					GamePlaySound( "data/audio/Desktop/projectiles.bank", "player_projectiles/bullet_burst_of_air/create", x, y )
				end
				if getMaterialCount(material_name, colon) < 1 then
					AddMaterialInventoryMaterial(colon, material_name, 0)
				end
				break
			end
		end
	end
	if fartable < 1 or math.random(100) == 1 then ComponentSetValue2(expelletory_status, "value_int", 0) end
elseif fert ~= true then
	ComponentSetValue2(fartcomp, "count_min", 0)
	ComponentSetValue2(fartcomp, "count_max", 0)
end

-----------------------------------------------------------------------------------------
--URINATION
-----------------------------------------------------------------------------------------
local bladder_count = getMaterialCount("all", bladder)
if bladder_count > 0 and ComponentGetValue2( controls, "mButtonDownInteract") then
	local material = IngestedMaterialsList(bladder)[math.random(1,#IngestedMaterialsList(bladder))]
	
	local x2,y2 = ComponentGetValue2( controls, "mAimingVector")
	local interp = bladder_count^2 * 0.01
	local curve = ((bladder_count^2 * 0.1)+(bladder_count^0.5 * interp)) / interp + 1
	local dist = math.sqrt((x2^2) + (y2^2))
	local vel_x = (((x2*(0.015*curve))+(math.random(-10,10)*0.15))*100) / dist
	local vel_y = (((y2*(0.015*curve))+(math.random(-10,10)*0.15))*100) / dist

	local factor = 1
	if (x2 > 0 and entity_vel_x < 0) or (x2 < 0 and entity_vel_x > 0) then factor = -1 end
	ComponentSetValue2(peecomp, "emitted_material_name", material)
	ComponentSetValue2(peecomp, "x_vel_max", math.abs(vel_x)+(math.abs(entity_vel_x)*50*factor))
	ComponentSetValue2(peecomp, "x_vel_min", math.abs(vel_x)+(math.abs(entity_vel_x)*50*factor))
	ComponentSetValue2(peecomp, "y_vel_max", vel_y+entity_vel_y)
	ComponentSetValue2(peecomp, "y_vel_min", vel_y+entity_vel_y)
	ComponentSetValue2(peecomp, "count_min", 1)
	ComponentSetValue2(peecomp, "count_max", 1)
	AddMaterialInventoryMaterial(bladder, material, getMaterialCount(material, bladder) - 1)
	--GamePlaySound( "data/audio/Desktop/materials.bank", "materials/spray_potion", x, y )
else
	ComponentSetValue2(peecomp, "count_min", 0)
	ComponentSetValue2(peecomp, "count_max", 0)
end

-----------------------------------------------------------------------------------------
--UPHEAVAL
-----------------------------------------------------------------------------------------
local burpable = getMaterialCount("gases", stomach) + getMaterialCount("fires", stomach)
if ((vomitable_count > 1 and math.random(1+math.floor(10000/vomitable_count)) == 1) or (ComponentGetValue2(expelletory_status, "value_int") == 3)) and ComponentGetValue2(fpc, "value_int") ~= 2 then
	crouch = true
	local material_inventory = EntityGetFirstComponentIncludingDisabled(entity, "MaterialInventoryComponent")
	local count_per_material_type = ComponentGetValue2( material_inventory, "count_per_material_type")
	local x2,y2 = ComponentGetValue2( controls, "mAimingVector")
	local interp = vomitable_count^2 * 0.01
	local curve = ((vomitable_count^2 * 0.1)+(vomitable_count^0.5 * interp)) / interp + 1
	local dist = math.sqrt((x2^2) + (y2^2))
	local vel_x = (((x2*(0.015*curve))+(math.random(-10,10)*0.15))*100) / dist
	local vel_y = (((y2*(0.015*curve))+(math.random(-10,10)*0.15))*100) / dist
	local offset = 3.3
	if x2 > 0 then offset = 2.3 end
	ComponentSetValue2(vomitcomp, "offset", offset,-1)
	local factor = 1
	if (x2 > 0 and entity_vel_x < 0) or (x2 < 0 and entity_vel_x > 0) then factor = -1 end

	material_name = IngestedMaterialsList()[math.random(#IngestedMaterialsList())]
	particle_material = material_name
	material_amount = getMaterialCount(material_name)

	if string.find(material_name, "meat") ~= nil and string.find(material_name, "sand") == nil then particle_material = "meat_slime_sand" end

	local count = math.random(0, 5)
	ComponentSetValue2(vomitcomp, "emitted_material_name", particle_material)
	ComponentSetValue2(vomitcomp, "count_min", count)
	ComponentSetValue2(vomitcomp, "count_max", count)
	ComponentSetValue2(vomitcomp, "x_vel_min", math.abs(vel_x)+(math.abs(entity_vel_x)*50*factor))
	ComponentSetValue2(vomitcomp, "x_vel_max", 25+math.abs(vel_x)+(math.abs(entity_vel_x)*50*factor))
	ComponentSetValue2(vomitcomp, "y_vel_max", vel_y+entity_vel_y)
	ComponentSetValue2(vomitcomp, "y_vel_min", vel_y+entity_vel_y)
	ComponentSetValue2(vomitcomp, "emit_real_particles", true)
	ComponentSetValue2(vomitcomp, "fade_based_on_lifetime", false)
	AddMaterialInventoryMaterial(entity, material_name, material_amount - count)
	vomitable_count = vomitable_count - count

	local stone_to_upchuck = swallowed_entities[1]
	if stone_to_upchuck and SkipFrames(10) then upchuck_stone(stone_to_upchuck, x, y, vel_x*2, vel_y*2) end

	if ComponentGetValue2(expelletory_status, "value_int") ~= 3 then
		GamePlaySound( "data/audio/Desktop/misc.bank", "game_effect/food_poisoning/create", x, y )
		ComponentSetValue2(expelletory_status, "value_int", 3)
	end
	if getMaterialCount(material_name) < 1 then
		AddMaterialInventoryMaterial(entity, material_name, 0)
	end
	if vomitable_count < 1 or math.random(100) == 1 then 
		if vomitable_count < 1 then EntityRemoveIngestionStatusEffect( entity, "FOOD_POISONING" ) end
		ComponentSetValue2(expelletory_status, "value_int", 0) 
	end

elseif (burpable > 100 and math.random(1+math.floor(100000/burpable)) == 1) or (ComponentGetValue2(expelletory_status, "value_int") == 5) then
	-----------------------------------------------------------------------------------------
	--BURP
	-----------------------------------------------------------------------------------------
	local material_inventory = EntityGetFirstComponentIncludingDisabled(stomach, "MaterialInventoryComponent")
	if material_inventory == nil then return end
	local count_per_material_type = ComponentGetValue2( material_inventory, "count_per_material_type")
	local x2,y2 = ComponentGetValue2( controls, "mAimingVector")
	local interp = burpable^2 * 0.01
	local curve = ((burpable^2 * 0.1)+(burpable^0.5 * interp)) / interp + 1
	local dist = math.sqrt((x2^2) + (y2^2))
	local vel_x = (((x2*(0.015*curve))+(math.random(-10,10)*0.15))*100) / dist
	local vel_y = (((y2*(0.015*curve))+(math.random(-10,10)*0.15))*100) / dist
	local rand = 12
	local offset = 3.3
	if x2 > 0 then offset = 2.3 end
	ComponentSetValue2(vomitcomp, "offset", offset,-1)
	local factor = 1
	if (x2 > 0 and entity_vel_x < 0) or (x2 < 0 and entity_vel_x > 0) then factor = -1 end
	local count = math.random(0, 100)

	material_name = IngestedMaterialsList()[math.random(#IngestedMaterialsList())]
	tags = CellFactory_GetTags(CellFactory_GetType(material_name))
	if get_index(tags, "[gas]") or get_index(tags, "[fire]") then
		if get_index(tags, "[fire]") then 
			vel_x = vel_x * 3
			vel_y = vel_y * 3
			rand = 2
		end
		ComponentSetValue2(vomitcomp, "emitted_material_name", material_name)
		ComponentSetValue2(vomitcomp, "x_vel_min", (math.abs(vel_x)+(math.abs(entity_vel_x)*50*factor))-rand)
		ComponentSetValue2(vomitcomp, "x_vel_max", (math.abs(vel_x)+(math.abs(entity_vel_x)*50*factor))+rand)
		ComponentSetValue2(vomitcomp, "y_vel_min", (vel_y+entity_vel_y)-rand)
		ComponentSetValue2(vomitcomp, "y_vel_max", (vel_y+entity_vel_y)+rand)
		ComponentSetValue2(vomitcomp, "count_min", count)
		ComponentSetValue2(vomitcomp, "count_max", count)
		ComponentSetValue2(vomitcomp, "emit_real_particles", false)
		ComponentSetValue2(vomitcomp, "fade_based_on_lifetime", true)
		ComponentSetValue2(vomitcomp, "gravity", 0, 0)
		AddMaterialInventoryMaterial(stomach, material_name, getMaterialCount(material_name, colon) - count)
		if ComponentGetValue2(expelletory_status, "value_int") ~= 5 then
			ComponentSetValue2(expelletory_status, "value_int", 5)
			GamePlaySound( "data/audio/Desktop/animals.bank", "animals/frog_big/death", x, y )
			GamePlaySound( "data/audio/Desktop/materials.bank", "materials/lava_burst", x, y )
		end
		local hit, hit_x, hit_y = RaytraceSurfacesAndLiquiform( x, y, x+(vel_x/1.5), y+(vel_y/1.5) )
		if hit then
			GameCreateParticle( material_name, hit_x, hit_y, math.abs(count/10)+1, vel_x, vel_y, false)
		end
		if getMaterialCount(material_name, stomach) < 1 then
			AddMaterialInventoryMaterial(stomach, material_name, 0)
		end
	end
	if burpable < 1 or math.random(100) == 1 then ComponentSetValue2(expelletory_status, "value_int", 0) end
else
	ComponentSetValue2(vomitcomp, "count_min", 0)
	ComponentSetValue2(vomitcomp, "count_max", 0)
end
-----------------------------------------------------------------------------------------
--GUI ICONS
-----------------------------------------------------------------------------------------
list = {{"STOMACH"}, {"BLADDER"}, {"COLON"}}
for i,organ in pairs({stomach, bladder, colon}) do
	local material_inventory = EntityGetFirstComponentIncludingDisabled(organ, "MaterialInventoryComponent")
	local count_per_material_type = ComponentGetValue2( material_inventory, "count_per_material_type")
	for k,v in pairs(count_per_material_type) do
		if v ~= 0 then --material exists in the inventory
			material_name = GameTextGetTranslatedOrNot(CellFactory_GetUIName(k-1))
		    material_amount = v
		    if material_amount > 0 then
				table.insert(list[i], material_name .. "(" .. material_amount .. "ml)")
		    end
		end
	end
end
for i, stone in pairs(swallowed_entities_display) do
	local stone_name = stone[1]
	local stone_count = stone[2]
	local ml = " (" .. 200*stone_count .. ")"
	table.insert(list[1], stone_count .. " " .. StoneDisplayName(stone_name) .. ml)
end

--FEED WERM:
if worm_count > 0 then
	local worm_hp_comp = EntityGetFirstComponent(entity, "VariableStorageComponent", "worm_hp")
	local worm_hp = ComponentGetValue2(worm_hp_comp, "value_float")
	local plural = " lapamato ("
	if worm_count > 1 then plural = " lapamatoja (" end
	ComponentSetValue2(worm_hp_comp, "value_float", math.min(worm_hp + (hp_for_worms), 100))
	table.insert(list[3], worm_count .. plural .. math.floor(worm_hp) .. "ml)")
end


local length = {#list[1] or 0, #list[2] or 0, #list[3] or 0}
table.sort(length)
length = length[#length]

local tab = "                      "
local matlist = ""
for i=1,length do
	local column1 = list[1][i] or ""
	local column2 = list[2][i] or ""
	local column3 = list[3][i] or ""
	testgui = testgui or GuiCreate()
	local len1 = math.floor(GuiGetTextDimensions( testgui, column1, 1, 2 )/3)+1
	local len2 = math.floor(GuiGetTextDimensions( testgui, column2, 1, 2 )/3)+1
	local len3 = math.floor(GuiGetTextDimensions( testgui, column3, 1, 2 )/3)+1
	local add = column1 .. tab:sub(1,-len1) .. column2 .. tab:sub(1,-len2) .. column3 .. tab:sub(1,-len3)
	matlist = matlist .. add .. "\n"
end

local stomach_count = getMaterialCount("all", stomach) + swallowed_entity_space
local bladder_count = getMaterialCount("all", bladder)
local colon_count = getMaterialCount("all", colon) + hp_for_worms
local total_count = stomach_count + bladder_count + colon_count

almost_explode = false
rand_x, rand_y = 0, 0
col_rand_x, col_rand_y = 0, 0
blad_rand_x, blad_rand_y = 0, 0

local pressure_tier = "satiation_00"

if EntityHasTag( entity, "iron_stomach" ) or (getMaterialCount("magic_liquid_protection_all") > 0) then
	pressure_tier = "iron_stomach"
elseif total_count > 3000 then 
	EntityRemoveComponent( entity, EntityGetFirstComponentIncludingDisabled( entity, "StatusEffectDataComponent"))
	EntityAddComponent( entity, "StatusEffectDataComponent", {})
	ComponentSetValue2(EntityGetFirstComponentIncludingDisabled( entity, "StatusEffectDataComponent"), "on_death_spill", true)
	for i,organ in ipairs({bladder, colon}) do
		local mcomp = EntityGetFirstComponentIncludingDisabled( organ, "MaterialInventoryComponent")
		ComponentSetValue2(mcomp, "on_death_spill", true)
		EntityRemoveFromParent(organ)
		EntityKill(organ)
	end
	if ComponentGetValue2( dmc, "hp") > 0.08 then ComponentSetValue2( dmc, "hp", 0.08) end
	EntityInflictDamage( entity, 1, "DAMAGE_OVEREATING", "overeating", "NORMAL", x, y)
	explosion = EntityLoad( "data/entities/misc/overeating_explosion.xml", x, y )
elseif total_count > 1750 then 
	almost_explode = true
	pressure_tier = "ingestion_damage"
	rand_x, rand_y = math.floor(math.random(0,total_count-1750)/50), math.floor(math.random(0,total_count-1750)/50)
elseif total_count > 1500 then 
	pressure_tier = "satiation_06"
elseif total_count > 1250 then 
	pressure_tier = "satiation_05"
elseif total_count > 1000 then 
	pressure_tier = "satiation_04"
elseif total_count > 750 then 
	pressure_tier = "satiation_03"
elseif total_count > 500 then 
	pressure_tier = "satiation_02"
elseif total_count > 250 then 
	pressure_tier = "satiation_01"
end
stomach_gui = stomach_gui or GuiCreate()
GuiStartFrame(stomach_gui)
GuiImage( stomach_gui, 2, 600+rand_x, 200+rand_y, "data/ui_gfx/status_indicators/" .. pressure_tier .. ".png", 1, 1, 1, 0, 0, "")
local stomach_text = (math.floor(total_count/10) .. "%      ")
local stomach_offset = GuiGetTextDimensions( stomach_gui, stomach_text, 1, 2 )
GuiText( stomach_gui, 620-stomach_offset, 200, stomach_text )
GuiTooltip( stomach_gui, "", matlist )


if not EntityHasTag(entity, "paralyzed") then
	local platcomp = EntityGetFirstComponentIncludingDisabled( entity, "CharacterPlatformingComponent" )
	ComponentSetValue2( platcomp, "run_velocity", 160 - (total_count/22))
	ComponentSetValue2( platcomp, "fly_velocity_x", 52 - (total_count/100))
	ComponentSetValue2( platcomp, "fly_speed_max_up", 95 - (total_count/60))
end

if almost_explode then 
	warning_gui = warning_gui or GuiCreate()
	GuiText( warning_gui, 270, 290, "Press [E] to expel waste" )
end
if crouch == true then
	local char = EntityGetFirstComponentIncludingDisabled( entity, "CharacterDataComponent")
	if ComponentGetValue2( char, "mFramesOnGround") > 3 then --is on ground?
		x2,y2 = ComponentGetValue2( controls, "mAimingVector")
		if math.abs(entity_vel_x) < 0.2 then
			if ComponentGetValue2(controls, "mButtonDownDown") then
				GamePlayAnimation( entity, "eat", 10)
			else 
				GamePlayAnimation( entity, "stand_crouched", 10) 
			end
		else
			if (x2/math.abs(x2)) == (entity_vel_x/math.abs(entity_vel_x)) then --if entity is facing the direction it's moving in
				GamePlayAnimation( entity, "walk_crouched", 10) 
			else
				GamePlayAnimation( entity, "walk_backwards_crouched", 10) 
			end
		end
	else
		GamePlayAnimation( entity, "walk_backwards_crouched", 10) 
	end
	ComponentSetValue2(crouching, "value_bool", true)
elseif ComponentGetValue2(crouching, "value_bool") == true then
	EntityRemoveComponent( entity, EntityGetFirstComponentIncludingDisabled( entity, "SpriteAnimatorComponent"))
	EntityAddComponent( entity, "SpriteAnimatorComponent", {})
	ComponentSetValue2(crouching, "value_bool", false)
end
