dofile_once("mods/ir/files/functions.lua")

--DEFINE THINGS:
local entity = GetUpdatedEntityID()
local ex, ey = EntityGetTransform(entity)
local verlet_physics_component = EntityGetFirstComponent(entity, "VerletPhysicsComponent")
local targ_comp = EntityGetFirstComponent(entity, "VariableStorageComponent", "target")
local target = ComponentGetValue2(targ_comp, "value_int")
local positions = ComponentGetValue2(verlet_physics_component, "positions")
local positions_prev = ComponentGetValue2(verlet_physics_component, "positions_prev")

--GET THE EXISTING TARGET ENTITY OR GET NEW:
if target == 0 then
    target = EntityGetInRadiusWithTag(ex, ey, 40, "homing_target")[1]
    if not target then goto finish end
elseif not EntityGetTransform(target) then 
    target = EntityGetInRadiusWithTag(positions[19], positions[20], 20, "ragdoll_entity")[1]
    if not target then
        target = EntityGetInRadiusWithTag(ex, ey, 40, "homing_target")[1]
        if not target then
            ComponentSetValue2(targ_comp, "value_int", 0)
            goto finish
        end
    end
end
ComponentSetValue2(targ_comp, "value_int", target)
local px, py, prot = EntityGetTransform(target)
local dist = Distance(px,py,ex,ey)

if dist > 200 then
    EntityRemoveComponent(entity, EntityGetFirstComponent(entity, "LuaComponent"))
    ComponentSetValue2(targ_comp, "value_int", 0)
    goto finish
end

--CONSTRAIN ENTITY:
constrain(target, ex, ey, 30)

--APPLY VERLET CHANGES
local plusx, plusy = MoveCoordsAlongVector(ex, ey, px, py, dist*1.1)
positions[19] = plusx
positions[20] = plusy
positions_prev[19] = plusx
positions_prev[20] = plusy
ComponentSetValue2(verlet_physics_component, "positions_prev", positions_prev)
ComponentSetValue2(verlet_physics_component, "positions", positions)

::finish::