dofile_once("mods/ir/files/functions.lua")

local entity = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity)
local genome = ComponentGetValue2(EntityGetFirstComponent(entity, "GenomeDataComponent"), "herd_id")
local entity_chardatacomp = EntityGetFirstComponent(entity, "CharacterDataComponent")
local sedc = EntityGetFirstComponent(entity, "StatusEffectDataComponent")
local entity_platcomp = EntityGetFirstComponent(entity, "CharacterPlatformingComponent")
local aicomp = EntityGetFirstComponent(entity, "AnimalAIComponent")
local pathcomp = EntityGetFirstComponent(entity, "PathFindingComponent")
local move_x, move_y = ComponentGetValue2(pathcomp, "path_next_node_vector_to")
local movemag = Distance(0,0,move_x,move_y)
if movemag > 20 then move_x, move_y = MoveCoordsAlongVector(0,0,move_x,move_y,20) end
local pvel_x, pvel_y = ComponentGetValue2(entity_chardatacomp, "mVelocity")
local charm = 0
if EntityHasTag(entity, "worm_charmer") then charm = 1 end
local desired_vel_x = move_x
local desired_vel_y = move_y-3.888
--local dbg = EntityGetWithTag("debug")[1]
--EntitySetTransform(dbg, x+move_x, y+move_y)


local all_worms = {}
local anchors={}
local target_entities = {}
local attached_one = false

--GET HOW MANY OF WERM:
for i, child in ipairs(EntityGetAllChildren(entity)) do
    if EntityGetName(child) == "worm" then
        local state_comp = EntityGetFirstComponent(child, "VariableStorageComponent", "states")
        local targ_x_comp, targ_y_comp = EntityGetFirstComponent(child, "VariableStorageComponent", "target_x"), EntityGetFirstComponent(child, "VariableStorageComponent", "target_y")
        local targ_x, targ_y = ComponentGetValue2(targ_x_comp, "value_int"), ComponentGetValue2(targ_y_comp, "value_int")
        local states = ComponentGetValue2(state_comp, "value_string")
        local coords = {targ_x, targ_y}
        table.insert(all_worms, child)
        local target_entity = ComponentGetValue2(EntityGetFirstComponent(child, "VariableStorageComponent", "target_entity"), "value_int")
        if target_entity ~= 0 then table.insert(target_entities, target_entity) end
        if states == "prosthesisattached" then table.insert(anchors, coords) end
    end
end
local anchor_count = #anchors
local worm_count = #all_worms




--FIND INCOMING PROJECTILE:
local threat = GetIncomingProjectile(x,y-4,70,target_entities)
--FIND A VISIBLE ENEMY IN RANGE:
local enemy = GetAttackableEnemy(x,y-4,150,genome,target_entities)
local ex, ey = EntityGetTransform(enemy)
local enemy_dist = 10000000
if ex then 
    enemy_dist = Distance(x,y,ex,ey) 
end
--FIND A PHYSICS OBJECT WITHIN GRASP:
local phys_objs = EntityGetInRadius(x,y,70)
for i, obj in ipairs(phys_objs) do
    local physcomp = EntityGetFirstComponent(obj, "PhysicsBodyComponent") or EntityGetFirstComponent(obj, "PhysicsBody2Component")
    if physcomp or EntityHasTag(obj, "ragdoll_entity") then 
        phys_obj = obj
        x3, y3 = EntityGetTransform(phys_obj)
        phys_dist = Distance(x,y,x3,y3)
    end
end

--GET FORCE REQUIRED TO MAINTAIN DESIRED ENTITY VELOCITY:
local corrective_x = 0
local corrective_y = 0
if anchor_count > 0 then
    corrective_x = (((-pvel_x/10) + desired_vel_x) / anchor_count)
    corrective_y = (((-pvel_y/10) + desired_vel_y) / anchor_count)
end
local corrective_mag = Distance(x, y, x+corrective_x, y+corrective_y)

--FIND WHERE SUPPORT IS NEEDED MOST IN ORDER TO CREATE SAID FORCE:
local x4, y4 = MoveCoordsAlongVector(x, y, x+corrective_x, y+corrective_y, 100) 
local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, x4, y4)
if not did_hit then
    x4, y4 = MoveCoordsAlongVector(x, y, x-corrective_x, y-corrective_y, 100) 
    did_hit, hit_x, hit_y = RaytracePlatforms(x, y, x4, y4)
end
if hit_x == x then did_hit = false end

--CHECK IF ENTITY IS APTLY SUPPORTED ALREADY:
local lacking_support = true
for i, anchor in ipairs(anchors) do
    local ax, ay = anchor[1], anchor[2]
    if Distance(hit_x, hit_y, ax, ay) < ((corrective_mag*10)+5) or not did_hit then
        lacking_support = false
        break
    end
end

--ITERATE ALL THE WERM:
for i, worm in ipairs(all_worms) do
    local verlet_physics_component = EntityGetFirstComponent(worm, "VerletPhysicsComponent")
    local state_comp = EntityGetFirstComponent(worm, "VariableStorageComponent", "states")
    local time_comp = EntityGetFirstComponent(worm, "VariableStorageComponent", "time")
    local targ_x_comp, targ_y_comp = EntityGetFirstComponent(worm, "VariableStorageComponent", "target_x"), EntityGetFirstComponent(worm, "VariableStorageComponent", "target_y")
    local targ_entity_comp = EntityGetFirstComponent(worm, "VariableStorageComponent", "target_entity")

    local positions = ComponentGetValue2(verlet_physics_component, "positions")
    local positions_prev = ComponentGetValue2(verlet_physics_component, "positions_prev")
    local states = ComponentGetValue2(state_comp, "value_string")
    local time = ComponentGetValue2(time_comp, "value_int")
    local target_entity = ComponentGetValue2(targ_entity_comp, "value_int")
    local targ_x, targ_y = ComponentGetValue2(targ_x_comp, "value_int"), ComponentGetValue2(targ_y_comp, "value_int")
    local x2, y2 = EntityGetTransform(target_entity)
    if x2 then threat_dist = Distance(x,y,x2,y2) end
    local cosmetic_force_x = 0
    local cosmetic_force_y = 0

    if charm == 1 then
        --GET TARGET ENTITY OR FIND A NEW ONE:
        if not x2 and states ~= "KILL" then
            if threat and not attached_one then
                target_entity = threat
                x2, y2 = EntityGetTransform(target_entity)
                ComponentSetValue2(targ_entity_comp, "value_int", target_entity)
                time = math.random(80)
                states = "KILL"
                attached_one = true
            elseif enemy and (enemy_dist < 70 or x3) and not attached_one then
                target_entity = enemy
                x2, y2 = EntityGetTransform(target_entity)
                ComponentSetValue2(targ_entity_comp, "value_int", target_entity)
                time = 0
                states = "KILL"
                attached_one = true
            elseif target_entity ~= 0 then
                ComponentSetValue2(targ_entity_comp, "value_int", 0)
                time = 0
                target_entity = 0
            end
        end
        if states == "KILL" then
            local x2, y2 = EntityGetTransform(target_entity)
            if x2 then threat_dist = Distance(x,y,x2,y2) end
            if not x2 then
                local nearby_ragdoll = EntityGetInRadiusWithTag(positions[19], positions[20], 10, "ragdoll_entity")[1]
                if nearby_ragdoll and not get_index(target_entities, nearby_ragdoll) then
                    target_entity = nearby_ragdoll
                    ComponentSetValue2(targ_entity_comp, "value_int", target_entity) 
                    table.insert(target_entities, target_entity)
                    x2, y2 = EntityGetTransform(target_entity)
                    threat_dist = Distance(x,y,x2,y2)
                    time = math.random(70)
                else
                    states = "prosthesis"
                    ComponentSetValue2(targ_entity_comp, "value_int", 0)
                    time = 0
                    target_entity = 0
                    goto kill_end
                end
            end
            if EntityHasTag(target_entity, "projectile") then
                local factor = 1
                if target_entity % 2 == 0 then factor = -1 end
                local force_out_x, force_out_y = ((x2-x)/(threat_dist^2)), ((y2-(y-4))/(threat_dist^2))
                local force_parallel_x, force_parallel_y = factor * ((y2-(y-4))/threat_dist), -factor *((x2-x)/threat_dist)
                local forcex, forcey = force_out_x+force_parallel_x, force_out_y+force_parallel_y
                EntityApplyForce(target_entity, forcex*20, forcey*20)
                EntityApplyForce(entity, -forcex, -forcey)
                cosmetic_force_x = cosmetic_force_x + (forcex*20)
                cosmetic_force_y = cosmetic_force_y + (forcey*20)
                time = time + 1
                if threat_dist > 70 or time > 100 then
                    ComponentSetValue2(targ_entity_comp, "value_int", 0)
                    states = "prosthesis"
                end
            elseif x3 and not EntityHasTag(target_entity, "ragdoll_entity") then-- if physics object near
                positions[19] = x3
                positions[20] = y3
                positions_prev[19] = x3
                positions_prev[20] = y3
                local forcex, forcey = (x2-x3)/(threat_dist/50), ((y2-4)-y3)/(threat_dist/50)
                EntityApplyForce(phys_obj, forcex, forcey)
                EntityApplyForce(phys_obj, (x-x3)/(phys_dist^2), ((y-4)-y3)/(phys_dist^2))
                cosmetic_force_x = cosmetic_force_x + (forcex)
                cosmetic_force_y = cosmetic_force_y + (forcey)
                phys_obj = nil
                x3, y3 = nil, nil

                if not EntityGetFirstComponent(target_entity, "LuaComponent", "phys_damage_giver") then
                    EntityAddComponent( target_entity, "LuaComponent", {
                        _tags="phys_damage_giver",
                        execute_every_n_frame="1",
                        script_source_file="mods/ir/files/give_phys_damage.lua",
                        remove_after_executed="0",
                        })
                    end
                if math.random(50) == 1 then 
                    states = "prosthesis"
                    ComponentSetValue2(targ_entity_comp, "value_int", 0)
                end
                goto kill_end
            elseif threat_dist < 75 then
                constrain(entity, x2, y2, 70)
            else
                ComponentSetValue2(targ_entity_comp, "value_int", 0)
                states = "prosthesis"
                goto kill_end
            end
            positions[19] = x2
            positions[20] = y2
            positions_prev[19] = x2
            positions_prev[20] = y2
            constrain(target_entity, x, y, 70)
            --if entity killed then throw corpse, else drain hp:
            if EntityHasTag(target_entity, "ragdoll_entity") then
                PhysicsApplyForce(target_entity, (x-x2), (y-y2))
                cosmetic_force_x = cosmetic_force_x + (x-x2)
                cosmetic_force_y = cosmetic_force_y + (y-y2)
                time = time + 1
                if time > 100 then 
                    ComponentSetValue2(targ_entity_comp, "value_int", 0)
                    states = "prosthesis"
                end
            elseif not EntityHasTag(target_entity, "projectile") then
                local targ_dmc = EntityGetFirstComponent(target_entity, "DamageModelComponent")
                local targ_hp = ComponentGetValue2(targ_dmc, "hp")
                if targ_hp - 0.04 <= 0 then
                    LoadGameEffectEntityTo( target_entity, "data/entities/misc/effect_ragdoll_entitify_short.xml" )
                end
                EntityInflictDamage(target_entity, 0.04, "DAMAGE_MATERIAL", "excessive blood donation to " .. GameTextGetTranslatedOrNot(EntityGetName(entity)) .. "'s lapamato", "NONE", 0, 0, entity)
            end
            ::kill_end::
        end
        if worm_count > 4 and not ComponentGetValue2(entity_chardatacomp, "is_on_ground") then
            --FIND SURFACES TO ATTACH TO:
            if states == "prosthesis" and not attached_one then
                if not did_hit or not lacking_support then
                    x4, y4 = MoveCoordsAlongVector(x+corrective_x, y+corrective_y, x+corrective_x+math.random(-30,30), y+corrective_y+math.random(-30,30), 100) 
                    did_hit, hit_x, hit_y = RaytracePlatforms(x, y, x4, y4)
                end
                if hit_x == x then did_hit = false end
            
                if did_hit then
                    states = "prosthesisattached"
                    ComponentSetValue2(targ_x_comp, "value_int", hit_x)
                    ComponentSetValue2(targ_y_comp, "value_int", hit_y)
                    targ_x = hit_x
                    targ_y = hit_y
                    attached_one = true
                    lacking_support = false
                    GamePlaySound( "data/audio/Desktop/player.bank", "player/step_slime", hit_x, hit_y )
                end
            end
            --MOVE ENTITY:
            if states == "prosthesisattached" then
                local dist3 = Distance(x,y,targ_x,targ_y)
                local plusx, plusy = MoveCoordsAlongVector(x, y, targ_x, targ_y, dist3*1.1)
                positions[19] = plusx
                positions[20] = plusy
                positions_prev[19] = plusx
                positions_prev[20] = plusy
            
                local dist = math.sqrt((((x+(corrective_x/10))-targ_x)^2) + (((y+(corrective_y/10))-targ_y)^2))--get the length the worm would be if the entity were moving at the desired velocity
                local entity_targ_x, entity_targ_y = MoveCoordsAlongVector(targ_x, targ_y, x, y, dist) --force from worm to entity
                local mag = math.sqrt(((entity_targ_x-targ_x)^2) + ((entity_targ_y-targ_y)^2)) --magnitude of force
                if not string.match(tostring((entity_targ_x-x) * 20),"nan") then 
                    --pvel_x = pvel_x + (entity_targ_x-x) * 20
                    --pvel_y = pvel_y + (entity_targ_y-y) * 20
                    EntityApplyForce(entity, (entity_targ_x-x) * 20, (entity_targ_y-y) * 20)
                    cosmetic_force_x = cosmetic_force_x + ((entity_targ_x-x) * 20)
                    cosmetic_force_y = cosmetic_force_y + ((entity_targ_y-y) * 20)
                end
                if Distance(targ_x, targ_y, x+corrective_x, y+corrective_y) > 100 then
                    states = "prosthesis"
                elseif lacking_support then
                    if not did_hit then
                        x4, y4 = MoveCoordsAlongVector(x+corrective_x, y+corrective_y, x+corrective_x+math.random(-30,30), y+corrective_y+math.random(-30,30), 100) 
                        did_hit, hit_x, hit_y = RaytracePlatforms(x, y, x4, y4)
                    end
                    if hit_x == x then did_hit = false end
                
                    if did_hit then
                        ComponentSetValue2(targ_x_comp, "value_int", hit_x)
                        ComponentSetValue2(targ_y_comp, "value_int", hit_y)
                        attached_one = true
                        lacking_support = false
                        GamePlaySound( "data/audio/Desktop/player.bank", "player/step_slime", hit_x, hit_y )
                    end
                end
            end
        end
    end

    --WIGGLE AROUND:
    for i=3,19,2 do
        positions_prev[i] = ((positions_prev[i]*9) + positions_prev[i-2]) / 10 --inherits some of the next chain-link's x velocity
        positions_prev[i+1] = (((positions_prev[i+1]*9) + positions_prev[i-1]) / 10) + 0.01 --inherits some of the next chain-link's y velocity, plus an upward force
        positions_prev[i] = positions_prev[i] + (cosmetic_force_x/100)
        positions_prev[i+1] = positions_prev[i+1] + (cosmetic_force_y/100)
    end
    --push the end of the chain around in random directions:
    positions_prev[19] = positions_prev[19] + math.random(-20,20)/20
    positions_prev[20] = positions_prev[20] + math.random(-20,20)/20
    --lay eggs:
    if math.random(1000) == 1 then
		GameCreateParticle("worm_egg", positions[19], positions[20], 1, 0, 0, false)
    end
    --APPLY_CHANGES:
    ComponentSetValue2(verlet_physics_component, "positions_prev", positions_prev)
    ComponentSetValue2(verlet_physics_component, "positions", positions)
    ComponentSetValue2(time_comp, "value_int", time)
    ComponentSetValue2(state_comp, "value_string", states)
end
if charm == 1 and worm_count > 4 and not ComponentGetValue2(entity_chardatacomp, "is_on_ground") then
    local pvel_x, pvel_y = ComponentGetValue2(entity_chardatacomp, "mVelocity")
    ComponentSetValue2(entity_chardatacomp, "mVelocity", pvel_x*1.13, pvel_y)
    if not EntityHasTag(entity, "paralyzed") then
        ComponentSetValue2(pathcomp, "can_fly", true)
        ComponentSetValue2(entity_chardatacomp, "fly_time_max", 0)
        ComponentSetValue2(entity_platcomp, "run_velocity", 0)
        ComponentSetValue2(entity_platcomp, "fly_velocity_x", 0)
        ComponentSetValue2(entity_platcomp, "fly_speed_mult", 0)
        EntityAddTag(entity, "paralyzed")
    end
elseif EntityHasTag(entity, "paralyzed") then
    if charm == 0 and worm_count < 5 then ComponentSetValue2(pathcomp, "can_fly", false) end
    ComponentSetValue2(entity_chardatacomp, "fly_time_max", 3)
    ComponentSetValue2(entity_platcomp, "run_velocity", 160)
    ComponentSetValue2(entity_platcomp, "fly_velocity_x", 52)
    ComponentSetValue2(entity_platcomp, "fly_speed_mult", 20)
    EntityRemoveTag(entity, "paralyzed")
end